<!DOCTYPE html>

<html lang="en" data-content_root="../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.core.api_client &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.core.api_client</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo define uma interface para clientes API autenticados dentro do sistema SAGACE. </span>
<span class="sd">A classe `APIClient` fornece uma estrutura base para requisições autenticadas, garantindo que qualquer implementação</span>
<span class="sd">específica siga um contrato comum.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Gerenciamento da URL base da API.</span>
<span class="sd">- Armazenamento e recuperação do token de autenticação.</span>
<span class="sd">- Definição de um método abstrato para requisições autenticadas.</span>

<span class="sd">Classes:</span>

<span class="sd">- ``APIClient``: Interface para clientes autenticados.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.infrastructure.api_client import APIClient</span>
<span class="sd">    from sagace.core import TokenStorage</span>

<span class="sd">    class MyAPIClient(APIClient):</span>
<span class="sd">        def request(self, method: str, endpoint: str, **kwargs):</span>
<span class="sd">            # Implementação específica da requisição</span>
<span class="sd">            pass</span>

<span class="sd">    api_client = MyAPIClient(&quot;https://api.sagace.online&quot;, TokenStorage())</span>


<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 16:20</span>
<span class="sd">Criado em: 27/02/2025 16:20</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span><span class="w"> </span><span class="nn">abc</span><span class="w"> </span><span class="kn">import</span> <span class="n">ABC</span><span class="p">,</span> <span class="n">abstractmethod</span>

<span class="kn">from</span><span class="w"> </span><span class="nn">.</span><span class="w"> </span><span class="kn">import</span> <span class="n">TokenStorage</span>


<div class="viewcode-block" id="APIClient">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.api_client.APIClient">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">APIClient</span><span class="p">(</span><span class="n">ABC</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Interface para clientes API autenticados.</span>

<span class="sd">    Esta classe serve como base para a implementação de clientes API que necessitam de autenticação.</span>

<span class="sd">    Princípios aplicados:</span>

<span class="sd">    - **Liskov Substitution (L - SOLID)**: Qualquer classe que herde de `APIClient` deve poder ser utilizada</span>
<span class="sd">      sem alterar o comportamento esperado.</span>
<span class="sd">    - **Dependency Inversion (D - SOLID)**: Depende da abstração de um armazenamento de tokens (`TokenStorage`).</span>

<span class="sd">    :param base_url: URL base da API.</span>
<span class="sd">    :type base_url: str</span>
<span class="sd">    :param token_storage: Instância responsável pelo armazenamento do token.</span>
<span class="sd">    :type token_storage: TokenStorage</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span><span class="w"> </span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">base_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">token_storage</span><span class="p">:</span> <span class="n">TokenStorage</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Inicializa a classe APIClient.</span>

<span class="sd">        :param base_url: URL base da API.</span>
<span class="sd">        :type base_url: str</span>
<span class="sd">        :param token_storage: Instância responsável pelo armazenamento do token.</span>
<span class="sd">        :type token_storage: TokenStorage</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="c1"># Remove qualquer barra extra no final da URL base para evitar problemas de formatação.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">base_url</span> <span class="o">=</span> <span class="n">base_url</span><span class="o">.</span><span class="n">rstrip</span><span class="p">(</span><span class="s2">&quot;/&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">token_storage</span> <span class="o">=</span> <span class="n">token_storage</span>

<div class="viewcode-block" id="APIClient.request">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.api_client.APIClient.request">[docs]</a>
    <span class="nd">@abstractmethod</span>
    <span class="k">def</span><span class="w"> </span><span class="nf">request</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Realiza uma requisição autenticada à API.</span>

<span class="sd">        Este método deve ser implementado pelas classes concretas que herdam de `APIClient`.</span>

<span class="sd">        :param method: Método HTTP a ser utilizado (GET, POST, etc.).</span>
<span class="sd">        :type method: str</span>
<span class="sd">        :param endpoint: Caminho do endpoint na API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para a requisição.</span>
<span class="sd">        :return: Resposta da API.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">pass</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>